package com.faraphel.tasks_valider.database.dao

import androidx.room.Dao
import androidx.room.Query
import androidx.room.RewriteQueriesToDropUnusedColumns
import com.faraphel.tasks_valider.database.dao.base.BaseDao
import com.faraphel.tasks_valider.database.entities.Group
import com.faraphel.tasks_valider.database.entities.Student


@Dao
interface GroupDao : BaseDao<Group> {
    @Query("SELECT * FROM `groups`")
    override fun getAll(): List<Group>

    @Query("SELECT * FROM `groups` WHERE id = :id")
    fun getById(id: Long): Group

    /**
    Allow to get all groups with a specific student
     */
    @Query(
        "SELECT * FROM `groups` " +
        "JOIN `group_student` ON `groups`.id = `group_student`.student_id " +
        "WHERE `group_student`.student_id = :studentId"
    )
    @RewriteQueriesToDropUnusedColumns
    fun filterByStudentId(studentId: Long): List<Group>
}
